# Carbon DeFi Dev

## Carbon DeFi Dev

- [Introducing Carbon DeFi](https://docs.carbondefi.xyz/carbon-defi/introducing-carbon-defi.md)
- [What Makes Carbon DeFi Unique?](https://docs.carbondefi.xyz/carbon-defi/introducing-carbon-defi/what-makes-carbon-defi-unique.md)
- [Fees & Payments](https://docs.carbondefi.xyz/carbon-defi/introducing-carbon-defi/fees-and-payments.md)
- [Resources](https://docs.carbondefi.xyz/carbon-defi/introducing-carbon-defi/resources.md)
- [Security & Audits](https://docs.carbondefi.xyz/carbon-defi/security-and-audits.md)
- [Contracts](https://docs.carbondefi.xyz/contracts-and-functions/contracts.md)
- [CarbonController](https://docs.carbondefi.xyz/contracts-and-functions/contracts/carboncontroller.md)
- [CarbonVortex](https://docs.carbondefi.xyz/contracts-and-functions/contracts/carbonvortex.md)
- [CarbonVortexBridge](https://docs.carbondefi.xyz/contracts-and-functions/contracts/carbonvortexbridge.md)
- [Deployments](https://docs.carbondefi.xyz/contracts-and-functions/contracts/deployments.md)
- [Mainnet Contracts](https://docs.carbondefi.xyz/contracts-and-functions/contracts/deployments/mainnet-contracts.md)
- [Testnet Contracts](https://docs.carbondefi.xyz/contracts-and-functions/contracts/deployments/testnet-contracts.md)
- [CarbonController Functions](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions.md)
- [Write Functions](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions.md)
- [Transaction Prerequisites](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions/transaction-prerequisites.md)
- [approve() / allowance()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions/transaction-prerequisites/approve-allowance.md)
- [Trade](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions/trade.md)
- [tradeBySourceAmount()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions/trade/tradebysourceamount.md)
- [tradeByTargetAmount()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions/trade/tradebytargetamount.md)
- [Strategy Management](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions/strategy-management.md)
- [createStrategy()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions/strategy-management/createstrategy.md)
- [updateStrategy](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions/strategy-management/updatestrategy.md)
- [deleteStrategy()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/write-functions/strategy-management/deletestrategy.md)
- [Read Functions](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions.md)
- [controllerType()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/controllertype.md)
- [tradingFeePPM()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/tradingfeeppm.md)
- [pairTradingFeePPM()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/pairtradingfeeppm.md)
- [pair()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/pair.md)
- [pairs()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/pairs.md)
- [strategy()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/strategy.md)
- [strategiesByPair()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/strategiesbypair.md)
- [strategiesByPairCount()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/strategiesbypaircount.md)
- [calculateTradeSourceAmount()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/calculatetradesourceamount.md)
- [calculateTradeTargetAmount()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/read-functions/calculatetradetargetamount.md)
- [Data & Events](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events.md)
- [TradingFeePPMUpdated()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events/tradingfeeppmupdated.md)
- [PairCreated()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events/paircreated.md)
- [StrategyCreated()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events/strategycreated.md)
- [StrategyDeleted()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events/strategydeleted.md)
- [StrategyUpdated()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events/strategyupdated.md)
- [TokensTraded()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events/tokenstraded.md)
- [FeesWithdrawn()](https://docs.carbondefi.xyz/contracts-and-functions/carboncontroller-functions/data-and-events/feeswithdrawn.md)
- [CarbonVortex Functions](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions.md)
- [Write Functions](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/write-functions.md)
- [trade()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/write-functions/trade.md)
- [execute()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/write-functions/execute.md)
- [Read Functions](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions.md)
- [amountAvailableForTrading()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/amountavailablefortrading.md)
- [availableTokens()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/availabletokens.md)
- [expectedTradeInput()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/expectedtradeinput.md)
- [expectedTradeReturn()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/expectedtradereturn.md)
- [finalTargetToken()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/finaltargettoken.md)
- [minTargetTokenSaleAmount()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/mintargettokensaleamount.md)
- [minTokenSaleAmount()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/mintokensaleamount.md)
- [pairDisabled()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/pairdisabled.md)
- [priceDecayHalfLife()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/pricedecayhalflife.md)
- [rewardsPPM()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/rewardsppm.md)
- [targetToken()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/targettoken.md)
- [targetTokenPriceDecayHalfLife()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/targettokenpricedecayhalflife.md)
- [targetTokenSaleAmount()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/targettokensaleamount.md)
- [tokenPrice()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/tokenprice.md)
- [totalCollected()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/totalcollected.md)
- [tradingEnabled()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortex-functions/read-functions/tradingenabled.md)
- [CarbonVortexBridge Functions](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortexbridge-functions.md)
- [Write Functions](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortexbridge-functions/write-functions.md)
- [Bridge()](https://docs.carbondefi.xyz/contracts-and-functions/carbonvortexbridge-functions/write-functions/bridge.md): For chains that support StarGate bridge
- [Carbon DeFi Public REST API](https://docs.carbondefi.xyz/rest-api/carbon-defi-public-rest-api.md)
- [AI Agents & MCP Server](https://docs.carbondefi.xyz/rest-api/ai-agents-and-mcp-server.md)
- [Carbon DeFi SDK](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk.md)
- [Getting started](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/getting-started.md)
- [Interacting with the SDK](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/interacting-with-the-sdk.md)
- [Managing Strategies](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/interacting-with-the-sdk/managing-strategies.md)
- [Performing Trades](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/interacting-with-the-sdk/performing-trades.md)
- [Getting User and Pair Data](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/interacting-with-the-sdk/getting-user-and-pair-data.md)
- [Collecting Liquidity Data](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/interacting-with-the-sdk/collecting-liquidity-data.md)
- [SDK Functions](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions.md)
- [constructor](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/constructor.md)
- [startDataSync](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/startdatasync.md)
- [getCachedPairs](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/getcachedpairs.md)
- [hasLiquidityByPair](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/hasliquiditybypair.md)
- [getLiquidityByPair](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/getliquiditybypair.md)
- [getUserStrategies](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/getuserstrategies.md)
- [getTradeData](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/gettradedata.md)
- [composeTradeByTargetTransaction](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/composetradebytargettransaction.md)
- [composeTradeBySourceTransaction](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/composetradebysourcetransaction.md)
- [createBuySellStrategy](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/createbuysellstrategy.md)
- [updateStrategy](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/updatestrategy.md)
- [deleteStrategy](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/deletestrategy.md)
- [getMinRateByPair](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/getminratebypair.md)
- [getMaxRateByPair](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/getmaxratebypair.md)
- [getRateLiquidityDepthByPair](https://docs.carbondefi.xyz/developer-guides/carbon-defi-sdk/sdk-functions/getrateliquiditydepthbypair.md)
- [The Carbon DeFi versus Uniswap V3 Invariant Functions](https://docs.carbondefi.xyz/developer-guides/the-carbon-defi-versus-uniswap-v3-invariant-functions.md)
- [Carbon DeFi Subgraph](https://docs.carbondefi.xyz/developer-guides/carbon-defi-subgraph.md)
- [Accessing the Subgraph](https://docs.carbondefi.xyz/developer-guides/carbon-defi-subgraph/accessing-the-subgraph.md)
- [Creating Subgraph Queries](https://docs.carbondefi.xyz/developer-guides/carbon-defi-subgraph/creating-subgraph-queries.md)
- [Subgraph Query in Python](https://docs.carbondefi.xyz/developer-guides/carbon-defi-subgraph/subgraph-query-in-python.md)
- [Sample Subgraph Queries](https://docs.carbondefi.xyz/developer-guides/carbon-defi-subgraph/sample-subgraph-queries.md)
- [Using CarbonVortex](https://docs.carbondefi.xyz/developer-guides/using-carbonvortex.md)
- [CarbonVortex Dynamics](https://docs.carbondefi.xyz/developer-guides/using-carbonvortex/carbonvortex-dynamics.md)
- [Carbon DeFi Transaction Encoding](https://docs.carbondefi.xyz/developer-guides/carbon-defi-transaction-encoding.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information, you can query the documentation dynamically by asking a question.
Perform an HTTP GET request on a page URL with the `ask` query parameter:
```
GET https://docs.carbondefi.xyz/carbon-defi/introducing-carbon-defi.md?ask=<question>
```
The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.
Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
